/* eval.c generated by valac 0.56.18, the Vala compiler
 * generated from eval.vala, do not modify */

/* Lisp eval

   Copyright (c) 2001-2020 Free Software Foundation, Inc.

   This file is part of GNU Zile.

   GNU Zile is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3, or (at your option)
   any later version.

   GNU Zile is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, see <https://www.gnu.org/licenses/>.  */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <gobject/gvaluecollector.h>
#include <stdarg.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

typedef gboolean (*MovementDelegate) (gpointer user_data);
typedef gboolean (*MovementNDelegate) (gpointer user_data, glong uniarg);

#define TYPE_LISP_FUNC (lisp_func_get_type ())
#define LISP_FUNC(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LISP_FUNC, LispFunc))
#define LISP_FUNC_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LISP_FUNC, LispFuncClass))
#define IS_LISP_FUNC(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LISP_FUNC))
#define IS_LISP_FUNC_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LISP_FUNC))
#define LISP_FUNC_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LISP_FUNC, LispFuncClass))

typedef struct _LispFunc LispFunc;
typedef struct _LispFuncClass LispFuncClass;
typedef struct _LispFuncPrivate LispFuncPrivate;
typedef gboolean (*Function) (glong uniarg, GeeQueue* args);
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
typedef struct _ParamSpecLispFunc ParamSpecLispFunc;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _lisp_func_unref0(var) ((var == NULL) ? NULL : (var = (lisp_func_unref (var), NULL)))

#define TYPE_HISTORY (history_get_type ())
#define HISTORY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_HISTORY, History))
#define HISTORY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_HISTORY, HistoryClass))
#define IS_HISTORY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_HISTORY))
#define IS_HISTORY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_HISTORY))
#define HISTORY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_HISTORY, HistoryClass))

typedef struct _History History;
typedef struct _HistoryClass HistoryClass;

#define TYPE_COMPLETION (completion_get_type ())
#define COMPLETION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_COMPLETION, Completion))
#define COMPLETION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_COMPLETION, CompletionClass))
#define IS_COMPLETION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_COMPLETION))
#define IS_COMPLETION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_COMPLETION))
#define COMPLETION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_COMPLETION, CompletionClass))

typedef struct _Completion Completion;
typedef struct _CompletionClass CompletionClass;
typedef struct _Block5Data Block5Data;
#define _completion_unref0(var) ((var == NULL) ? NULL : (var = (completion_unref (var), NULL)))
typedef struct _CompletionPrivate CompletionPrivate;

#define TYPE_BUFFER (buffer_get_type ())
#define BUFFER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BUFFER, Buffer))
#define BUFFER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BUFFER, BufferClass))
#define IS_BUFFER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BUFFER))
#define IS_BUFFER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BUFFER))
#define BUFFER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BUFFER, BufferClass))

typedef struct _Buffer Buffer;
typedef struct _BufferClass BufferClass;
typedef enum  {
	COMPLETION_FLAGS_POPPEDUP = 1 << 0,
	COMPLETION_FLAGS_CLOSE = 1 << 1,
	COMPLETION_FLAGS_FILENAME = 1 << 2
} CompletionFlags;

#define COMPLETION_TYPE_FLAGS (completion_flags_get_type ())
typedef enum  {
	FLAGS_NEED_RESYNC = 1 << 0,
	FLAGS_SET_UNIARG = 1 << 1,
	FLAGS_UNIARG_EMPTY = 1 << 2,
	FLAGS_DEFINING_MACRO = 1 << 3
} Flags;

#define TYPE_FLAGS (flags_get_type ())

struct _LispFunc {
	GTypeInstance parent_instance;
	volatile int ref_count;
	LispFuncPrivate * priv;
	gchar* name;
	Function func;
	gboolean interactive;
	gchar* doc;
};

struct _LispFuncClass {
	GTypeClass parent_class;
	void (*finalize) (LispFunc *self);
};

struct _ParamSpecLispFunc {
	GParamSpec parent_instance;
};

struct _Block5Data {
	int _ref_count_;
	Completion* cp;
};

struct _Completion {
	GTypeInstance parent_instance;
	volatile int ref_count;
	CompletionPrivate * priv;
	gchar* match;
	Buffer* old_bp;
	GeeSortedSet* completions;
	GeeSortedSet* matches;
	glong matchsize;
	CompletionFlags flags;
	gchar* path;
};

struct _CompletionClass {
	GTypeClass parent_class;
	void (*finalize) (Completion *self);
};

static gpointer lisp_func_parent_class = NULL;
VALA_EXTERN GHashTable* lisp_func_table;
GHashTable* lisp_func_table = NULL;
VALA_EXTERN History* functions_history;
History* functions_history = NULL;
VALA_EXTERN Flags lastflag;

VALA_EXTERN gpointer lisp_func_ref (gpointer instance);
VALA_EXTERN void lisp_func_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_lisp_func (const gchar* name,
                                  const gchar* nick,
                                  const gchar* blurb,
                                  GType object_type,
                                  GParamFlags flags);
VALA_EXTERN void value_set_lisp_func (GValue* value,
                          gpointer v_object);
VALA_EXTERN void value_take_lisp_func (GValue* value,
                           gpointer v_object);
VALA_EXTERN gpointer value_get_lisp_func (const GValue* value);
VALA_EXTERN GType lisp_func_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LispFunc, lisp_func_unref)
VALA_EXTERN LispFunc* lisp_func_new (const gchar* name,
                         Function func,
                         gboolean interactive,
                         const gchar* doc);
VALA_EXTERN LispFunc* lisp_func_construct (GType object_type,
                               const gchar* name,
                               Function func,
                               gboolean interactive,
                               const gchar* doc);
VALA_EXTERN LispFunc* lisp_func_find (const gchar* name);
static void _g_free0_ (gpointer var);
static void _lisp_func_unref0_ (gpointer var);
static void lisp_func_finalize (LispFunc * obj);
static GType lisp_func_get_type_once (void);
VALA_EXTERN gboolean execute_with_uniarg (glong uniarg,
                              MovementDelegate forward,
                              gpointer forward_target,
                              MovementDelegate backward,
                              gpointer backward_target);
VALA_EXTERN gboolean move_with_uniarg (glong uniarg,
                           MovementNDelegate move,
                           gpointer move_target);
VALA_EXTERN gboolean execute_function (const gchar* name,
                           glong uniarg,
                           gboolean is_uniarg);
VALA_EXTERN gboolean call_command (LispFunc* f,
                       glong uniarg,
                       GeeQueue* args);
VALA_EXTERN gpointer history_ref (gpointer instance);
VALA_EXTERN void history_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_history (const gchar* name,
                                const gchar* nick,
                                const gchar* blurb,
                                GType object_type,
                                GParamFlags flags);
VALA_EXTERN void value_set_history (GValue* value,
                        gpointer v_object);
VALA_EXTERN void value_take_history (GValue* value,
                         gpointer v_object);
VALA_EXTERN gpointer value_get_history (const GValue* value);
VALA_EXTERN GType history_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (History, history_unref)
VALA_EXTERN gchar* minibuf_read_function_name (const gchar* fmt,
                                   ...);
VALA_EXTERN gpointer completion_ref (gpointer instance);
VALA_EXTERN void completion_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_completion (const gchar* name,
                                   const gchar* nick,
                                   const gchar* blurb,
                                   GType object_type,
                                   GParamFlags flags);
VALA_EXTERN void value_set_completion (GValue* value,
                           gpointer v_object);
VALA_EXTERN void value_take_completion (GValue* value,
                            gpointer v_object);
VALA_EXTERN gpointer value_get_completion (const GValue* value);
VALA_EXTERN GType completion_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Completion, completion_unref)
static Block5Data* block5_data_ref (Block5Data* _data5_);
static void block5_data_unref (void * _userdata_);
VALA_EXTERN Completion* completion_new (gboolean fileflag);
VALA_EXTERN Completion* completion_construct (GType object_type,
                                  gboolean fileflag);
static void __lambda25_ (Block5Data* _data5_,
                  const gchar* name,
                  LispFunc* f);
VALA_EXTERN gpointer buffer_ref (gpointer instance);
VALA_EXTERN void buffer_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_buffer (const gchar* name,
                               const gchar* nick,
                               const gchar* blurb,
                               GType object_type,
                               GParamFlags flags);
VALA_EXTERN void value_set_buffer (GValue* value,
                       gpointer v_object);
VALA_EXTERN void value_take_buffer (GValue* value,
                        gpointer v_object);
VALA_EXTERN gpointer value_get_buffer (const GValue* value);
VALA_EXTERN GType buffer_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Buffer, buffer_unref)
VALA_EXTERN GType completion_flags_get_type (void) G_GNUC_CONST ;
static void ___lambda25__gh_func (gconstpointer key,
                           gconstpointer value,
                           gpointer self);
VALA_EXTERN gchar* minibuf_vread_completion (const gchar* fmt,
                                 const gchar* val,
                                 Completion* cp,
                                 History* hp,
                                 const gchar* empty_err,
                                 const gchar* invalid_err,
                                 va_list ap);
VALA_EXTERN void eval_init (void);
VALA_EXTERN History* history_new (void);
VALA_EXTERN History* history_construct (GType object_type);
static gboolean __lambda33_ (glong uniarg,
                      GeeQueue* args);
VALA_EXTERN void set_variable (const gchar* name,
                   const gchar* val);
static gboolean ___lambda33__function (glong uniarg,
                                GeeQueue* args);
static gboolean __lambda34_ (glong uniarg,
                      GeeQueue* args);
VALA_EXTERN GType flags_get_type (void) G_GNUC_CONST ;
static gboolean ___lambda34__function (glong uniarg,
                                GeeQueue* args);

static gpointer
_lisp_func_ref0 (gpointer self)
{
#line 47 "src/eval.vala"
	return self ? lisp_func_ref (self) : NULL;
#line 292 "eval.c"
}

LispFunc*
lisp_func_construct (GType object_type,
                     const gchar* name,
                     Function func,
                     gboolean interactive,
                     const gchar* doc)
{
	LispFunc* self = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	GHashTable* _tmp2_;
	gchar* _tmp3_;
	LispFunc* _tmp4_;
#line 41 "src/eval.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 41 "src/eval.vala"
	g_return_val_if_fail (doc != NULL, NULL);
#line 41 "src/eval.vala"
	self = (LispFunc*) g_type_create_instance (object_type);
#line 42 "src/eval.vala"
	_tmp0_ = g_strdup (name);
#line 42 "src/eval.vala"
	_g_free0 (self->name);
#line 42 "src/eval.vala"
	self->name = _tmp0_;
#line 43 "src/eval.vala"
	self->func = func;
#line 44 "src/eval.vala"
	self->interactive = interactive;
#line 45 "src/eval.vala"
	_tmp1_ = g_strdup (doc);
#line 45 "src/eval.vala"
	_g_free0 (self->doc);
#line 45 "src/eval.vala"
	self->doc = _tmp1_;
#line 47 "src/eval.vala"
	_tmp2_ = lisp_func_table;
#line 47 "src/eval.vala"
	_tmp3_ = g_strdup (name);
#line 47 "src/eval.vala"
	_tmp4_ = _lisp_func_ref0 (self);
#line 47 "src/eval.vala"
	g_hash_table_insert (_tmp2_, _tmp3_, _tmp4_);
#line 41 "src/eval.vala"
	return self;
#line 340 "eval.c"
}

LispFunc*
lisp_func_new (const gchar* name,
               Function func,
               gboolean interactive,
               const gchar* doc)
{
#line 41 "src/eval.vala"
	return lisp_func_construct (TYPE_LISP_FUNC, name, func, interactive, doc);
#line 351 "eval.c"
}

LispFunc*
lisp_func_find (const gchar* name)
{
	GHashTable* _tmp0_;
	gconstpointer _tmp1_;
	LispFunc* _tmp2_;
	LispFunc* result;
#line 50 "src/eval.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 51 "src/eval.vala"
	_tmp0_ = lisp_func_table;
#line 51 "src/eval.vala"
	_tmp1_ = g_hash_table_lookup (_tmp0_, name);
#line 51 "src/eval.vala"
	_tmp2_ = _lisp_func_ref0 ((LispFunc*) _tmp1_);
#line 51 "src/eval.vala"
	result = _tmp2_;
#line 51 "src/eval.vala"
	return result;
#line 373 "eval.c"
}

static void
_g_free0_ (gpointer var)
{
#line 38 "src/eval.vala"
	var = (g_free (var), NULL);
#line 381 "eval.c"
}

static void
_lisp_func_unref0_ (gpointer var)
{
#line 38 "src/eval.vala"
	(var == NULL) ? NULL : (var = (lisp_func_unref (var), NULL));
#line 389 "eval.c"
}

static void
value_lisp_func_init (GValue* value)
{
#line 29 "src/eval.vala"
	value->data[0].v_pointer = NULL;
#line 397 "eval.c"
}

static void
value_lisp_func_free_value (GValue* value)
{
#line 29 "src/eval.vala"
	if (value->data[0].v_pointer) {
#line 29 "src/eval.vala"
		lisp_func_unref (value->data[0].v_pointer);
#line 407 "eval.c"
	}
}

static void
value_lisp_func_copy_value (const GValue* src_value,
                            GValue* dest_value)
{
#line 29 "src/eval.vala"
	if (src_value->data[0].v_pointer) {
#line 29 "src/eval.vala"
		dest_value->data[0].v_pointer = lisp_func_ref (src_value->data[0].v_pointer);
#line 419 "eval.c"
	} else {
#line 29 "src/eval.vala"
		dest_value->data[0].v_pointer = NULL;
#line 423 "eval.c"
	}
}

static gpointer
value_lisp_func_peek_pointer (const GValue* value)
{
#line 29 "src/eval.vala"
	return value->data[0].v_pointer;
#line 432 "eval.c"
}

static gchar*
value_lisp_func_collect_value (GValue* value,
                               guint n_collect_values,
                               GTypeCValue* collect_values,
                               guint collect_flags)
{
#line 29 "src/eval.vala"
	if (collect_values[0].v_pointer) {
#line 443 "eval.c"
		LispFunc * object;
		object = collect_values[0].v_pointer;
#line 29 "src/eval.vala"
		if (object->parent_instance.g_class == NULL) {
#line 29 "src/eval.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 450 "eval.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 29 "src/eval.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 454 "eval.c"
		}
#line 29 "src/eval.vala"
		value->data[0].v_pointer = lisp_func_ref (object);
#line 458 "eval.c"
	} else {
#line 29 "src/eval.vala"
		value->data[0].v_pointer = NULL;
#line 462 "eval.c"
	}
#line 29 "src/eval.vala"
	return NULL;
#line 466 "eval.c"
}

static gchar*
value_lisp_func_lcopy_value (const GValue* value,
                             guint n_collect_values,
                             GTypeCValue* collect_values,
                             guint collect_flags)
{
	LispFunc ** object_p;
	object_p = collect_values[0].v_pointer;
#line 29 "src/eval.vala"
	if (!object_p) {
#line 29 "src/eval.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 481 "eval.c"
	}
#line 29 "src/eval.vala"
	if (!value->data[0].v_pointer) {
#line 29 "src/eval.vala"
		*object_p = NULL;
#line 487 "eval.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 29 "src/eval.vala"
		*object_p = value->data[0].v_pointer;
#line 491 "eval.c"
	} else {
#line 29 "src/eval.vala"
		*object_p = lisp_func_ref (value->data[0].v_pointer);
#line 495 "eval.c"
	}
#line 29 "src/eval.vala"
	return NULL;
#line 499 "eval.c"
}

GParamSpec*
param_spec_lisp_func (const gchar* name,
                      const gchar* nick,
                      const gchar* blurb,
                      GType object_type,
                      GParamFlags flags)
{
	ParamSpecLispFunc* spec;
#line 29 "src/eval.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_LISP_FUNC), NULL);
#line 29 "src/eval.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 29 "src/eval.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 29 "src/eval.vala"
	return G_PARAM_SPEC (spec);
#line 518 "eval.c"
}

gpointer
value_get_lisp_func (const GValue* value)
{
#line 29 "src/eval.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_LISP_FUNC), NULL);
#line 29 "src/eval.vala"
	return value->data[0].v_pointer;
#line 528 "eval.c"
}

void
value_set_lisp_func (GValue* value,
                     gpointer v_object)
{
	LispFunc * old;
#line 29 "src/eval.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_LISP_FUNC));
#line 29 "src/eval.vala"
	old = value->data[0].v_pointer;
#line 29 "src/eval.vala"
	if (v_object) {
#line 29 "src/eval.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_LISP_FUNC));
#line 29 "src/eval.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 29 "src/eval.vala"
		value->data[0].v_pointer = v_object;
#line 29 "src/eval.vala"
		lisp_func_ref (value->data[0].v_pointer);
#line 550 "eval.c"
	} else {
#line 29 "src/eval.vala"
		value->data[0].v_pointer = NULL;
#line 554 "eval.c"
	}
#line 29 "src/eval.vala"
	if (old) {
#line 29 "src/eval.vala"
		lisp_func_unref (old);
#line 560 "eval.c"
	}
}

void
value_take_lisp_func (GValue* value,
                      gpointer v_object)
{
	LispFunc * old;
#line 29 "src/eval.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_LISP_FUNC));
#line 29 "src/eval.vala"
	old = value->data[0].v_pointer;
#line 29 "src/eval.vala"
	if (v_object) {
#line 29 "src/eval.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_LISP_FUNC));
#line 29 "src/eval.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 29 "src/eval.vala"
		value->data[0].v_pointer = v_object;
#line 581 "eval.c"
	} else {
#line 29 "src/eval.vala"
		value->data[0].v_pointer = NULL;
#line 585 "eval.c"
	}
#line 29 "src/eval.vala"
	if (old) {
#line 29 "src/eval.vala"
		lisp_func_unref (old);
#line 591 "eval.c"
	}
}

static void
lisp_func_class_init (LispFuncClass * klass,
                      gpointer klass_data)
{
	GHashFunc _tmp0_;
	GEqualFunc _tmp1_;
	GHashTable* _tmp2_;
#line 29 "src/eval.vala"
	lisp_func_parent_class = g_type_class_peek_parent (klass);
#line 29 "src/eval.vala"
	((LispFuncClass *) klass)->finalize = lisp_func_finalize;
#line 38 "src/eval.vala"
	_tmp0_ = g_str_hash;
#line 38 "src/eval.vala"
	_tmp1_ = g_str_equal;
#line 38 "src/eval.vala"
	_tmp2_ = g_hash_table_new_full (_tmp0_, _tmp1_, _g_free0_, _lisp_func_unref0_);
#line 38 "src/eval.vala"
	_g_hash_table_unref0 (lisp_func_table);
#line 38 "src/eval.vala"
	lisp_func_table = _tmp2_;
#line 616 "eval.c"
}

static void
lisp_func_instance_init (LispFunc * self,
                         gpointer klass)
{
#line 29 "src/eval.vala"
	self->ref_count = 1;
#line 625 "eval.c"
}

static void
lisp_func_finalize (LispFunc * obj)
{
	LispFunc * self;
#line 29 "src/eval.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_LISP_FUNC, LispFunc);
#line 29 "src/eval.vala"
	g_signal_handlers_destroy (self);
#line 30 "src/eval.vala"
	_g_free0 (self->name);
#line 33 "src/eval.vala"
	_g_free0 (self->doc);
#line 640 "eval.c"
}

static GType
lisp_func_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_lisp_func_init, value_lisp_func_free_value, value_lisp_func_copy_value, value_lisp_func_peek_pointer, "p", value_lisp_func_collect_value, "p", value_lisp_func_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (LispFuncClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) lisp_func_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LispFunc), 0, (GInstanceInitFunc) lisp_func_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType lisp_func_type_id;
	lisp_func_type_id = g_type_register_fundamental (g_type_fundamental_next (), "LispFunc", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return lisp_func_type_id;
}

GType
lisp_func_get_type (void)
{
	static volatile gsize lisp_func_type_id__once = 0;
	if (g_once_init_enter (&lisp_func_type_id__once)) {
		GType lisp_func_type_id;
		lisp_func_type_id = lisp_func_get_type_once ();
		g_once_init_leave (&lisp_func_type_id__once, lisp_func_type_id);
	}
	return lisp_func_type_id__once;
}

gpointer
lisp_func_ref (gpointer instance)
{
	LispFunc * self;
	self = instance;
#line 29 "src/eval.vala"
	g_atomic_int_inc (&self->ref_count);
#line 29 "src/eval.vala"
	return instance;
#line 675 "eval.c"
}

void
lisp_func_unref (gpointer instance)
{
	LispFunc * self;
	self = instance;
#line 29 "src/eval.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 29 "src/eval.vala"
		LISP_FUNC_GET_CLASS (self)->finalize (self);
#line 29 "src/eval.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 689 "eval.c"
	}
}

gboolean
execute_with_uniarg (glong uniarg,
                     MovementDelegate forward,
                     gpointer forward_target,
                     MovementDelegate backward,
                     gpointer backward_target)
{
	gboolean _tmp0_ = FALSE;
	gboolean ret = FALSE;
	gboolean result;
#line 57 "src/eval.vala"
	if (backward != NULL) {
#line 57 "src/eval.vala"
		_tmp0_ = uniarg < ((glong) 0);
#line 707 "eval.c"
	} else {
#line 57 "src/eval.vala"
		_tmp0_ = FALSE;
#line 711 "eval.c"
	}
#line 57 "src/eval.vala"
	if (_tmp0_) {
#line 58 "src/eval.vala"
		forward = backward;
#line 58 "src/eval.vala"
		forward_target = backward_target;
#line 59 "src/eval.vala"
		uniarg = -uniarg;
#line 721 "eval.c"
	}
#line 61 "src/eval.vala"
	ret = TRUE;
#line 725 "eval.c"
	{
		gint uni = 0;
#line 62 "src/eval.vala"
		uni = 0;
#line 730 "eval.c"
		{
			gboolean _tmp1_ = FALSE;
#line 62 "src/eval.vala"
			_tmp1_ = TRUE;
#line 62 "src/eval.vala"
			while (TRUE) {
#line 737 "eval.c"
				gboolean _tmp3_ = FALSE;
#line 62 "src/eval.vala"
				if (!_tmp1_) {
#line 741 "eval.c"
					gint _tmp2_;
#line 62 "src/eval.vala"
					uni = uni + 1;
#line 62 "src/eval.vala"
					_tmp2_ = uni;
#line 747 "eval.c"
				}
#line 62 "src/eval.vala"
				_tmp1_ = FALSE;
#line 62 "src/eval.vala"
				if (ret) {
#line 62 "src/eval.vala"
					_tmp3_ = ((glong) uni) < uniarg;
#line 755 "eval.c"
				} else {
#line 62 "src/eval.vala"
					_tmp3_ = FALSE;
#line 759 "eval.c"
				}
#line 62 "src/eval.vala"
				if (!_tmp3_) {
#line 62 "src/eval.vala"
					break;
#line 765 "eval.c"
				}
#line 63 "src/eval.vala"
				ret = forward (forward_target);
#line 769 "eval.c"
			}
		}
	}
#line 65 "src/eval.vala"
	result = ret;
#line 65 "src/eval.vala"
	return result;
#line 777 "eval.c"
}

gboolean
move_with_uniarg (glong uniarg,
                  MovementNDelegate move,
                  gpointer move_target)
{
	gboolean ret = FALSE;
	gboolean result;
#line 69 "src/eval.vala"
	ret = TRUE;
#line 789 "eval.c"
	{
		gulong uni = 0UL;
#line 70 "src/eval.vala"
		uni = (gulong) 0;
#line 794 "eval.c"
		{
			gboolean _tmp0_ = FALSE;
#line 70 "src/eval.vala"
			_tmp0_ = TRUE;
#line 70 "src/eval.vala"
			while (TRUE) {
#line 801 "eval.c"
				gboolean _tmp2_ = FALSE;
				gint _tmp3_ = 0;
#line 70 "src/eval.vala"
				if (!_tmp0_) {
#line 806 "eval.c"
					gulong _tmp1_;
#line 70 "src/eval.vala"
					uni = uni + 1;
#line 70 "src/eval.vala"
					_tmp1_ = uni;
#line 812 "eval.c"
				}
#line 70 "src/eval.vala"
				_tmp0_ = FALSE;
#line 70 "src/eval.vala"
				if (ret) {
#line 70 "src/eval.vala"
					_tmp2_ = uni < ((gulong) labs (uniarg));
#line 820 "eval.c"
				} else {
#line 70 "src/eval.vala"
					_tmp2_ = FALSE;
#line 824 "eval.c"
				}
#line 70 "src/eval.vala"
				if (!_tmp2_) {
#line 70 "src/eval.vala"
					break;
#line 830 "eval.c"
				}
#line 71 "src/eval.vala"
				if (uniarg < ((glong) 0)) {
#line 71 "src/eval.vala"
					_tmp3_ = -1;
#line 836 "eval.c"
				} else {
#line 71 "src/eval.vala"
					_tmp3_ = 1;
#line 840 "eval.c"
				}
#line 71 "src/eval.vala"
				ret = move (move_target, (glong) _tmp3_);
#line 844 "eval.c"
			}
		}
	}
#line 72 "src/eval.vala"
	result = ret;
#line 72 "src/eval.vala"
	return result;
#line 852 "eval.c"
}

gboolean
execute_function (const gchar* name,
                  glong uniarg,
                  gboolean is_uniarg)
{
	LispFunc* func = NULL;
	LispFunc* _tmp0_;
	gboolean _tmp1_ = FALSE;
	LispFunc* _tmp2_;
	gboolean result;
#line 75 "src/eval.vala"
	g_return_val_if_fail (name != NULL, FALSE);
#line 76 "src/eval.vala"
	_tmp0_ = lisp_func_find (name);
#line 76 "src/eval.vala"
	func = _tmp0_;
#line 77 "src/eval.vala"
	_tmp2_ = func;
#line 77 "src/eval.vala"
	if (_tmp2_ != NULL) {
#line 875 "eval.c"
		GeeArrayQueue* _tmp3_ = NULL;
		LispFunc* _tmp5_;
#line 77 "src/eval.vala"
		if (is_uniarg) {
#line 77 "src/eval.vala"
			_g_object_unref0 (_tmp3_);
#line 77 "src/eval.vala"
			_tmp3_ = NULL;
#line 884 "eval.c"
		} else {
			GeeArrayQueue* _tmp4_;
#line 77 "src/eval.vala"
			_tmp4_ = gee_array_queue_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 77 "src/eval.vala"
			_g_object_unref0 (_tmp3_);
#line 77 "src/eval.vala"
			_tmp3_ = _tmp4_;
#line 893 "eval.c"
		}
#line 77 "src/eval.vala"
		_tmp5_ = func;
#line 77 "src/eval.vala"
		_tmp1_ = call_command (_tmp5_, uniarg, (GeeQueue*) _tmp3_);
#line 77 "src/eval.vala"
		_g_object_unref0 (_tmp3_);
#line 901 "eval.c"
	} else {
#line 77 "src/eval.vala"
		_tmp1_ = FALSE;
#line 905 "eval.c"
	}
#line 77 "src/eval.vala"
	result = _tmp1_;
#line 77 "src/eval.vala"
	_lisp_func_unref0 (func);
#line 77 "src/eval.vala"
	return result;
#line 913 "eval.c"
}

static Block5Data*
block5_data_ref (Block5Data* _data5_)
{
#line 84 "src/eval.vala"
	g_atomic_int_inc (&_data5_->_ref_count_);
#line 84 "src/eval.vala"
	return _data5_;
#line 923 "eval.c"
}

static void
block5_data_unref (void * _userdata_)
{
	Block5Data* _data5_;
	_data5_ = (Block5Data*) _userdata_;
#line 84 "src/eval.vala"
	if (g_atomic_int_dec_and_test (&_data5_->_ref_count_)) {
#line 84 "src/eval.vala"
		_completion_unref0 (_data5_->cp);
#line 84 "src/eval.vala"
		g_slice_free (Block5Data, _data5_);
#line 937 "eval.c"
	}
}

static void
__lambda25_ (Block5Data* _data5_,
             const gchar* name,
             LispFunc* f)
{
#line 87 "src/eval.vala"
	g_return_if_fail (name != NULL);
#line 87 "src/eval.vala"
	g_return_if_fail (f != NULL);
#line 88 "src/eval.vala"
	if (f->interactive) {
#line 952 "eval.c"
		GeeSortedSet* _tmp0_;
#line 89 "src/eval.vala"
		_tmp0_ = _data5_->cp->completions;
#line 89 "src/eval.vala"
		gee_collection_add ((GeeCollection*) _tmp0_, name);
#line 958 "eval.c"
	}
}

static void
___lambda25__gh_func (gconstpointer key,
                      gconstpointer value,
                      gpointer self)
{
#line 87 "src/eval.vala"
	__lambda25_ (self, (const gchar*) key, (LispFunc*) value);
#line 969 "eval.c"
}

gchar*
minibuf_read_function_name (const gchar* fmt,
                            ...)
{
	Block5Data* _data5_;
	Completion* _tmp0_;
	GHashTable* _tmp1_;
	History* _tmp2_;
	va_list _tmp3_ = {0};
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* result;
#line 84 "src/eval.vala"
	g_return_val_if_fail (fmt != NULL, NULL);
#line 84 "src/eval.vala"
	_data5_ = g_slice_new0 (Block5Data);
#line 84 "src/eval.vala"
	_data5_->_ref_count_ = 1;
#line 85 "src/eval.vala"
	_tmp0_ = completion_new (FALSE);
#line 85 "src/eval.vala"
	_data5_->cp = _tmp0_;
#line 87 "src/eval.vala"
	_tmp1_ = lisp_func_table;
#line 87 "src/eval.vala"
	g_hash_table_foreach (_tmp1_, ___lambda25__gh_func, _data5_);
#line 92 "src/eval.vala"
	_tmp2_ = functions_history;
#line 92 "src/eval.vala"
	va_start (_tmp3_, fmt);
#line 92 "src/eval.vala"
	_tmp4_ = minibuf_vread_completion (fmt, "", _data5_->cp, _tmp2_, "No function name given", "Undefined function name `%s'", _tmp3_);
#line 92 "src/eval.vala"
	_tmp5_ = _tmp4_;
#line 92 "src/eval.vala"
	va_end (_tmp3_);
#line 92 "src/eval.vala"
	result = _tmp5_;
#line 92 "src/eval.vala"
	block5_data_unref (_data5_);
#line 92 "src/eval.vala"
	_data5_ = NULL;
#line 92 "src/eval.vala"
	return result;
#line 1016 "eval.c"
}

static gboolean
__lambda33_ (glong uniarg,
             GeeQueue* args)
{
	gboolean result;
#line 104 "src/eval.vala"
	if (args != NULL) {
#line 105 "src/eval.vala"
		while (TRUE) {
#line 1028 "eval.c"
			gboolean _tmp0_;
			gboolean _tmp1_;
			gpointer _tmp2_;
			gchar* _tmp3_;
			gpointer _tmp4_;
			gchar* _tmp5_;
#line 105 "src/eval.vala"
			_tmp0_ = gee_collection_get_is_empty ((GeeCollection*) args);
#line 105 "src/eval.vala"
			_tmp1_ = _tmp0_;
#line 105 "src/eval.vala"
			if (!(!_tmp1_)) {
#line 105 "src/eval.vala"
				break;
#line 1043 "eval.c"
			}
#line 106 "src/eval.vala"
			_tmp2_ = gee_queue_poll (args);
#line 106 "src/eval.vala"
			_tmp3_ = (gchar*) _tmp2_;
#line 106 "src/eval.vala"
			_tmp4_ = gee_queue_poll (args);
#line 106 "src/eval.vala"
			_tmp5_ = (gchar*) _tmp4_;
#line 106 "src/eval.vala"
			set_variable (_tmp3_, _tmp5_);
#line 106 "src/eval.vala"
			_g_free0 (_tmp5_);
#line 106 "src/eval.vala"
			_g_free0 (_tmp3_);
#line 1059 "eval.c"
		}
	}
#line 107 "src/eval.vala"
	result = TRUE;
#line 107 "src/eval.vala"
	return result;
#line 1066 "eval.c"
}

static gboolean
___lambda33__function (glong uniarg,
                       GeeQueue* args)
{
	gboolean result;
	result = __lambda33_ (uniarg, args);
#line 101 "src/eval.vala"
	return result;
#line 1077 "eval.c"
}

static gboolean
__lambda34_ (glong uniarg,
             GeeQueue* args)
{
	gchar* msg = NULL;
	gchar* _tmp0_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* name = NULL;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	const gchar* _tmp9_;
	const gchar* _tmp10_;
	gboolean result;
#line 120 "src/eval.vala"
	_tmp0_ = g_strdup ("");
#line 120 "src/eval.vala"
	msg = _tmp0_;
#line 122 "src/eval.vala"
	if ((lastflag & FLAGS_SET_UNIARG) == FLAGS_SET_UNIARG) {
#line 123 "src/eval.vala"
		if ((lastflag & FLAGS_UNIARG_EMPTY) == FLAGS_UNIARG_EMPTY) {
#line 1102 "eval.c"
			gchar* _tmp1_;
#line 124 "src/eval.vala"
			_tmp1_ = g_strdup ("C-u ");
#line 124 "src/eval.vala"
			_g_free0 (msg);
#line 124 "src/eval.vala"
			msg = _tmp1_;
#line 1110 "eval.c"
		} else {
			gchar* _tmp2_;
			gchar* _tmp3_;
			gchar* _tmp4_;
#line 126 "src/eval.vala"
			_tmp2_ = g_strdup_printf ("%li", uniarg);
#line 126 "src/eval.vala"
			_tmp3_ = _tmp2_;
#line 126 "src/eval.vala"
			_tmp4_ = g_strconcat (_tmp3_, " ", NULL);
#line 126 "src/eval.vala"
			_g_free0 (msg);
#line 126 "src/eval.vala"
			msg = _tmp4_;
#line 126 "src/eval.vala"
			_g_free0 (_tmp3_);
#line 1127 "eval.c"
		}
	}
#line 128 "src/eval.vala"
	_tmp5_ = msg;
#line 128 "src/eval.vala"
	_tmp6_ = g_strconcat (_tmp5_, "M-x ", NULL);
#line 128 "src/eval.vala"
	_g_free0 (msg);
#line 128 "src/eval.vala"
	msg = _tmp6_;
#line 130 "src/eval.vala"
	_tmp7_ = msg;
#line 130 "src/eval.vala"
	_tmp8_ = minibuf_read_function_name ("%s", _tmp7_, NULL);
#line 130 "src/eval.vala"
	name = _tmp8_;
#line 131 "src/eval.vala"
	_tmp9_ = name;
#line 131 "src/eval.vala"
	if (_tmp9_ == NULL) {
#line 132 "src/eval.vala"
		result = FALSE;
#line 132 "src/eval.vala"
		_g_free0 (name);
#line 132 "src/eval.vala"
		_g_free0 (msg);
#line 132 "src/eval.vala"
		return result;
#line 1156 "eval.c"
	}
#line 134 "src/eval.vala"
	_tmp10_ = name;
#line 134 "src/eval.vala"
	result = execute_function (_tmp10_, uniarg, (lastflag & FLAGS_SET_UNIARG) == FLAGS_SET_UNIARG);
#line 134 "src/eval.vala"
	_g_free0 (name);
#line 134 "src/eval.vala"
	_g_free0 (msg);
#line 134 "src/eval.vala"
	return result;
#line 1168 "eval.c"
}

static gboolean
___lambda34__function (glong uniarg,
                       GeeQueue* args)
{
	gboolean result;
	result = __lambda34_ (uniarg, args);
#line 117 "src/eval.vala"
	return result;
#line 1179 "eval.c"
}

void
eval_init (void)
{
	History* _tmp0_;
	LispFunc* _tmp1_;
	LispFunc* _tmp2_;
	LispFunc* _tmp3_;
	LispFunc* _tmp4_;
#line 99 "src/eval.vala"
	_tmp0_ = history_new ();
#line 99 "src/eval.vala"
	functions_history = _tmp0_;
#line 101 "src/eval.vala"
	_tmp1_ = lisp_func_new ("setq", ___lambda33__function, FALSE, "(setq [sym val]...)\n" \
"\n" \
"\t  Set each sym to the value of its val.\n" \
"\t  The symbols sym are variables; they are literal (not evaluated).\n" \
"\t  The values val are expressions; they are evaluated.");
#line 101 "src/eval.vala"
	_tmp2_ = _tmp1_;
#line 101 "src/eval.vala"
	_lisp_func_unref0 (_tmp2_);
#line 117 "src/eval.vala"
	_tmp3_ = lisp_func_new ("execute-extended-command", ___lambda34__function, TRUE, "Read function name, then read its arguments and call it.");
#line 117 "src/eval.vala"
	_tmp4_ = _tmp3_;
#line 117 "src/eval.vala"
	_lisp_func_unref0 (_tmp4_);
#line 1206 "eval.c"
}

