/* help.c generated by valac 0.56.18, the Vala compiler
 * generated from help.vala, do not modify */

/* Self documentation facility functions

   Copyright (c) 1997-2021 Free Software Foundation, Inc.

   This file is part of GNU Zile.

   GNU Zile is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3, or (at your option)
   any later version.

   GNU Zile is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, see <https://www.gnu.org/licenses/>.  */

#include <glib.h>
#include <gee.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_LISP_FUNC (lisp_func_get_type ())
#define LISP_FUNC(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LISP_FUNC, LispFunc))
#define LISP_FUNC_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LISP_FUNC, LispFuncClass))
#define IS_LISP_FUNC(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LISP_FUNC))
#define IS_LISP_FUNC_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LISP_FUNC))
#define LISP_FUNC_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LISP_FUNC, LispFuncClass))

typedef struct _LispFunc LispFunc;
typedef struct _LispFuncClass LispFuncClass;
typedef struct _Block6Data Block6Data;
#define _lisp_func_unref0(var) ((var == NULL) ? NULL : (var = (lisp_func_unref (var), NULL)))
typedef void (*BufferWriter) (gpointer user_data);
typedef struct _LispFuncPrivate LispFuncPrivate;
typedef gboolean (*Function) (glong uniarg, GeeQueue* args);
typedef struct _Block7Data Block7Data;
typedef struct _Block8Data Block8Data;
typedef struct _Block9Data Block9Data;
typedef guint Keystroke;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block10Data Block10Data;

struct _Block6Data {
	int _ref_count_;
	LispFunc* func;
};

struct _LispFunc {
	GTypeInstance parent_instance;
	volatile int ref_count;
	LispFuncPrivate * priv;
	gchar* name;
	Function func;
	gboolean interactive;
	gchar* doc;
};

struct _LispFuncClass {
	GTypeClass parent_class;
	void (*finalize) (LispFunc *self);
};

struct _Block7Data {
	int _ref_count_;
	gchar* name;
};

struct _Block8Data {
	int _ref_count_;
	Block7Data * _data7_;
	gchar* doc;
};

struct _Block9Data {
	int _ref_count_;
	gchar* binding;
};

struct _Block10Data {
	int _ref_count_;
	Block9Data * _data9_;
	LispFunc* func;
};

VALA_EXTERN void help_init (void);
static gboolean __lambda88_ (glong uniarg,
                      GeeQueue* args);
VALA_EXTERN gchar* minibuf_read_function_name (const gchar* fmt,
                                   ...);
VALA_EXTERN gpointer lisp_func_ref (gpointer instance);
VALA_EXTERN void lisp_func_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_lisp_func (const gchar* name,
                                  const gchar* nick,
                                  const gchar* blurb,
                                  GType object_type,
                                  GParamFlags flags);
VALA_EXTERN void value_set_lisp_func (GValue* value,
                          gpointer v_object);
VALA_EXTERN void value_take_lisp_func (GValue* value,
                           gpointer v_object);
VALA_EXTERN gpointer value_get_lisp_func (const GValue* value);
VALA_EXTERN GType lisp_func_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LispFunc, lisp_func_unref)
static Block6Data* block6_data_ref (Block6Data* _data6_);
static void block6_data_unref (void * _userdata_);
VALA_EXTERN LispFunc* lisp_func_find (const gchar* name);
VALA_EXTERN void write_temp_buffer (const gchar* name,
                        gboolean show,
                        BufferWriter func,
                        gpointer func_target);
static void ____lambda89_ (Block6Data* _data6_);
VALA_EXTERN void bprintf (const gchar* fmt,
              ...);
static void _____lambda89__buffer_writer (gpointer self);
static gboolean ___lambda88__function (glong uniarg,
                                GeeQueue* args);
VALA_EXTERN LispFunc* lisp_func_new (const gchar* name,
                         Function func,
                         gboolean interactive,
                         const gchar* doc);
VALA_EXTERN LispFunc* lisp_func_construct (GType object_type,
                               const gchar* name,
                               Function func,
                               gboolean interactive,
                               const gchar* doc);
static gboolean __lambda90_ (glong uniarg,
                      GeeQueue* args);
static Block7Data* block7_data_ref (Block7Data* _data7_);
static void block7_data_unref (void * _userdata_);
VALA_EXTERN gchar* minibuf_read_variable_name (const gchar* fmt,
                                   ...);
static Block8Data* block8_data_ref (Block8Data* _data8_);
static void block8_data_unref (void * _userdata_);
VALA_EXTERN const gchar* get_variable_doc (const gchar* name,
                               const gchar** defval);
static void ____lambda92_ (Block8Data* _data8_);
VALA_EXTERN const gchar* get_variable (const gchar* name);
static void _____lambda92__buffer_writer (gpointer self);
static gboolean ___lambda90__function (glong uniarg,
                                GeeQueue* args);
static gboolean __lambda93_ (glong uniarg,
                      GeeQueue* args);
static Block9Data* block9_data_ref (Block9Data* _data9_);
static void block9_data_unref (void * _userdata_);
VALA_EXTERN GeeList* keystrtovec (const gchar* key);
VALA_EXTERN LispFunc* get_function_by_keys (GeeList* keys);
VALA_EXTERN gchar* keyvectodesc (GeeList* keys);
VALA_EXTERN void minibuf_write (const gchar* fmt,
                    ...);
VALA_EXTERN GeeList* get_key_sequence (void);
VALA_EXTERN void minibuf_error (const gchar* fmt,
                    ...);
static Block10Data* block10_data_ref (Block10Data* _data10_);
static void block10_data_unref (void * _userdata_);
static void ____lambda94_ (Block10Data* _data10_);
static void _____lambda94__buffer_writer (gpointer self);
static gboolean ___lambda93__function (glong uniarg,
                                GeeQueue* args);

static Block6Data*
block6_data_ref (Block6Data* _data6_)
{
#line 28 "src/help.vala"
	g_atomic_int_inc (&_data6_->_ref_count_);
#line 28 "src/help.vala"
	return _data6_;
#line 195 "help.c"
}

static void
block6_data_unref (void * _userdata_)
{
	Block6Data* _data6_;
	_data6_ = (Block6Data*) _userdata_;
#line 28 "src/help.vala"
	if (g_atomic_int_dec_and_test (&_data6_->_ref_count_)) {
#line 28 "src/help.vala"
		_lisp_func_unref0 (_data6_->func);
#line 28 "src/help.vala"
		g_slice_free (Block6Data, _data6_);
#line 209 "help.c"
	}
}

static void
____lambda89_ (Block6Data* _data6_)
{
	const gchar* _tmp0_ = NULL;
	LispFunc* _tmp1_;
	LispFunc* _tmp2_;
	const gchar* _tmp3_;
	LispFunc* _tmp4_;
	const gchar* _tmp5_;
#line 41 "src/help.vala"
	_tmp1_ = _data6_->func;
#line 41 "src/help.vala"
	if (_tmp1_->interactive) {
#line 41 "src/help.vala"
		_tmp0_ = "an interactive";
#line 228 "help.c"
	} else {
#line 41 "src/help.vala"
		_tmp0_ = "a";
#line 232 "help.c"
	}
#line 39 "src/help.vala"
	_tmp2_ = _data6_->func;
#line 39 "src/help.vala"
	_tmp3_ = _tmp2_->name;
#line 39 "src/help.vala"
	_tmp4_ = _data6_->func;
#line 39 "src/help.vala"
	_tmp5_ = _tmp4_->doc;
#line 39 "src/help.vala"
	bprintf ("%s is %s built-in function in `C source code'.\n\n%s", _tmp3_, _tmp0_, _tmp5_, NULL);
#line 244 "help.c"
}

static void
_____lambda89__buffer_writer (gpointer self)
{
#line 35 "src/help.vala"
	____lambda89_ (self);
#line 252 "help.c"
}

static gboolean
__lambda88_ (glong uniarg,
             GeeQueue* args)
{
	gboolean ok = FALSE;
	gchar* name = NULL;
	gpointer _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp3_;
	gboolean result;
#line 24 "src/help.vala"
	ok = TRUE;
#line 25 "src/help.vala"
	_tmp0_ = gee_queue_poll (args);
#line 25 "src/help.vala"
	name = (gchar*) _tmp0_;
#line 26 "src/help.vala"
	_tmp1_ = name;
#line 26 "src/help.vala"
	if (_tmp1_ == NULL) {
#line 275 "help.c"
		gchar* _tmp2_;
#line 27 "src/help.vala"
		_tmp2_ = minibuf_read_function_name ("Describe function: ", NULL);
#line 27 "src/help.vala"
		_g_free0 (name);
#line 27 "src/help.vala"
		name = _tmp2_;
#line 283 "help.c"
	}
#line 28 "src/help.vala"
	_tmp3_ = name;
#line 28 "src/help.vala"
	if (_tmp3_ == NULL) {
#line 29 "src/help.vala"
		ok = FALSE;
#line 291 "help.c"
	} else {
		Block6Data* _data6_;
		const gchar* _tmp4_;
		LispFunc* _tmp5_;
		LispFunc* _tmp6_;
#line 28 "src/help.vala"
		_data6_ = g_slice_new0 (Block6Data);
#line 28 "src/help.vala"
		_data6_->_ref_count_ = 1;
#line 31 "src/help.vala"
		_tmp4_ = name;
#line 31 "src/help.vala"
		_tmp5_ = lisp_func_find (_tmp4_);
#line 31 "src/help.vala"
		_data6_->func = _tmp5_;
#line 32 "src/help.vala"
		_tmp6_ = _data6_->func;
#line 32 "src/help.vala"
		if (_tmp6_ == NULL) {
#line 33 "src/help.vala"
			ok = FALSE;
#line 313 "help.c"
		} else {
#line 35 "src/help.vala"
			write_temp_buffer ("*Help*", TRUE, _____lambda89__buffer_writer, _data6_);
#line 317 "help.c"
		}
#line 28 "src/help.vala"
		block6_data_unref (_data6_);
#line 28 "src/help.vala"
		_data6_ = NULL;
#line 323 "help.c"
	}
#line 45 "src/help.vala"
	result = ok;
#line 45 "src/help.vala"
	_g_free0 (name);
#line 45 "src/help.vala"
	return result;
#line 331 "help.c"
}

static gboolean
___lambda88__function (glong uniarg,
                       GeeQueue* args)
{
	gboolean result;
	result = __lambda88_ (uniarg, args);
#line 21 "src/help.vala"
	return result;
#line 342 "help.c"
}

static Block7Data*
block7_data_ref (Block7Data* _data7_)
{
#line 53 "src/help.vala"
	g_atomic_int_inc (&_data7_->_ref_count_);
#line 53 "src/help.vala"
	return _data7_;
#line 352 "help.c"
}

static void
block7_data_unref (void * _userdata_)
{
	Block7Data* _data7_;
	_data7_ = (Block7Data*) _userdata_;
#line 53 "src/help.vala"
	if (g_atomic_int_dec_and_test (&_data7_->_ref_count_)) {
#line 53 "src/help.vala"
		_g_free0 (_data7_->name);
#line 53 "src/help.vala"
		g_slice_free (Block7Data, _data7_);
#line 366 "help.c"
	}
}

static Block8Data*
block8_data_ref (Block8Data* _data8_)
{
#line 58 "src/help.vala"
	g_atomic_int_inc (&_data8_->_ref_count_);
#line 58 "src/help.vala"
	return _data8_;
#line 377 "help.c"
}

static void
block8_data_unref (void * _userdata_)
{
	Block8Data* _data8_;
	_data8_ = (Block8Data*) _userdata_;
#line 58 "src/help.vala"
	if (g_atomic_int_dec_and_test (&_data8_->_ref_count_)) {
#line 58 "src/help.vala"
		_g_free0 (_data8_->doc);
#line 58 "src/help.vala"
		block7_data_unref (_data8_->_data7_);
#line 58 "src/help.vala"
		_data8_->_data7_ = NULL;
#line 58 "src/help.vala"
		g_slice_free (Block8Data, _data8_);
#line 395 "help.c"
	}
}

static void
____lambda92_ (Block8Data* _data8_)
{
	Block7Data* _data7_;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
#line 69 "src/help.vala"
	_data7_ = _data8_->_data7_;
#line 70 "src/help.vala"
	_tmp0_ = _data7_->name;
#line 70 "src/help.vala"
	_tmp1_ = _data7_->name;
#line 70 "src/help.vala"
	_tmp2_ = get_variable (_tmp1_);
#line 70 "src/help.vala"
	_tmp3_ = _data8_->doc;
#line 70 "src/help.vala"
	bprintf ("%s is a variable defined in `C source code'.\n" \
"\n" \
"Its value is %s\n" \
"\n" \
"%s", _tmp0_, _tmp2_, _tmp3_, NULL);
#line 419 "help.c"
}

static void
_____lambda92__buffer_writer (gpointer self)
{
#line 66 "src/help.vala"
	____lambda92_ (self);
#line 427 "help.c"
}

static gboolean
__lambda90_ (glong uniarg,
             GeeQueue* args)
{
	Block7Data* _data7_;
	gboolean ok = FALSE;
	gpointer _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp3_;
	gboolean result;
#line 53 "src/help.vala"
	_data7_ = g_slice_new0 (Block7Data);
#line 53 "src/help.vala"
	_data7_->_ref_count_ = 1;
#line 54 "src/help.vala"
	ok = TRUE;
#line 55 "src/help.vala"
	_tmp0_ = gee_queue_poll (args);
#line 55 "src/help.vala"
	_data7_->name = (gchar*) _tmp0_;
#line 56 "src/help.vala"
	_tmp1_ = _data7_->name;
#line 56 "src/help.vala"
	if (_tmp1_ == NULL) {
#line 454 "help.c"
		gchar* _tmp2_;
#line 57 "src/help.vala"
		_tmp2_ = minibuf_read_variable_name ("Describe variable: ", NULL);
#line 57 "src/help.vala"
		_g_free0 (_data7_->name);
#line 57 "src/help.vala"
		_data7_->name = _tmp2_;
#line 462 "help.c"
	}
#line 58 "src/help.vala"
	_tmp3_ = _data7_->name;
#line 58 "src/help.vala"
	if (_tmp3_ == NULL) {
#line 59 "src/help.vala"
		ok = FALSE;
#line 470 "help.c"
	} else {
		Block8Data* _data8_;
		gchar* defval = NULL;
		const gchar* _tmp4_;
		const gchar* _tmp5_ = NULL;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		const gchar* _tmp9_;
#line 58 "src/help.vala"
		_data8_ = g_slice_new0 (Block8Data);
#line 58 "src/help.vala"
		_data8_->_ref_count_ = 1;
#line 58 "src/help.vala"
		_data8_->_data7_ = block7_data_ref (_data7_);
#line 62 "src/help.vala"
		_tmp4_ = _data7_->name;
#line 62 "src/help.vala"
		_tmp6_ = get_variable_doc (_tmp4_, &_tmp5_);
#line 62 "src/help.vala"
		_g_free0 (defval);
#line 62 "src/help.vala"
		_tmp7_ = g_strdup (_tmp5_);
#line 62 "src/help.vala"
		defval = _tmp7_;
#line 62 "src/help.vala"
		_tmp8_ = g_strdup (_tmp6_);
#line 62 "src/help.vala"
		_data8_->doc = _tmp8_;
#line 63 "src/help.vala"
		_tmp9_ = _data8_->doc;
#line 63 "src/help.vala"
		if (_tmp9_ == NULL) {
#line 64 "src/help.vala"
			ok = FALSE;
#line 506 "help.c"
		} else {
#line 66 "src/help.vala"
			write_temp_buffer ("*Help*", TRUE, _____lambda92__buffer_writer, _data8_);
#line 510 "help.c"
		}
#line 58 "src/help.vala"
		_g_free0 (defval);
#line 58 "src/help.vala"
		block8_data_unref (_data8_);
#line 58 "src/help.vala"
		_data8_ = NULL;
#line 518 "help.c"
	}
#line 74 "src/help.vala"
	result = ok;
#line 74 "src/help.vala"
	block7_data_unref (_data7_);
#line 74 "src/help.vala"
	_data7_ = NULL;
#line 74 "src/help.vala"
	return result;
#line 528 "help.c"
}

static gboolean
___lambda90__function (glong uniarg,
                       GeeQueue* args)
{
	gboolean result;
	result = __lambda90_ (uniarg, args);
#line 51 "src/help.vala"
	return result;
#line 539 "help.c"
}

static Block9Data*
block9_data_ref (Block9Data* _data9_)
{
#line 82 "src/help.vala"
	g_atomic_int_inc (&_data9_->_ref_count_);
#line 82 "src/help.vala"
	return _data9_;
#line 549 "help.c"
}

static void
block9_data_unref (void * _userdata_)
{
	Block9Data* _data9_;
	_data9_ = (Block9Data*) _userdata_;
#line 82 "src/help.vala"
	if (g_atomic_int_dec_and_test (&_data9_->_ref_count_)) {
#line 82 "src/help.vala"
		_g_free0 (_data9_->binding);
#line 82 "src/help.vala"
		g_slice_free (Block9Data, _data9_);
#line 563 "help.c"
	}
}

static Block10Data*
block10_data_ref (Block10Data* _data10_)
{
#line 106 "src/help.vala"
	g_atomic_int_inc (&_data10_->_ref_count_);
#line 106 "src/help.vala"
	return _data10_;
#line 574 "help.c"
}

static void
block10_data_unref (void * _userdata_)
{
	Block10Data* _data10_;
	_data10_ = (Block10Data*) _userdata_;
#line 106 "src/help.vala"
	if (g_atomic_int_dec_and_test (&_data10_->_ref_count_)) {
#line 106 "src/help.vala"
		_lisp_func_unref0 (_data10_->func);
#line 106 "src/help.vala"
		block9_data_unref (_data10_->_data9_);
#line 106 "src/help.vala"
		_data10_->_data9_ = NULL;
#line 106 "src/help.vala"
		g_slice_free (Block10Data, _data10_);
#line 592 "help.c"
	}
}

static void
____lambda94_ (Block10Data* _data10_)
{
	Block9Data* _data9_;
	const gchar* _tmp0_ = NULL;
	LispFunc* _tmp1_;
	const gchar* _tmp2_;
	LispFunc* _tmp3_;
	const gchar* _tmp4_;
	LispFunc* _tmp5_;
	const gchar* _tmp6_;
#line 116 "src/help.vala"
	_data9_ = _data10_->_data9_;
#line 119 "src/help.vala"
	_tmp1_ = _data10_->func;
#line 119 "src/help.vala"
	if (_tmp1_->interactive) {
#line 119 "src/help.vala"
		_tmp0_ = "an interactive";
#line 615 "help.c"
	} else {
#line 119 "src/help.vala"
		_tmp0_ = "a";
#line 619 "help.c"
	}
#line 117 "src/help.vala"
	_tmp2_ = _data9_->binding;
#line 117 "src/help.vala"
	_tmp3_ = _data10_->func;
#line 117 "src/help.vala"
	_tmp4_ = _tmp3_->name;
#line 117 "src/help.vala"
	_tmp5_ = _data10_->func;
#line 117 "src/help.vala"
	_tmp6_ = _tmp5_->doc;
#line 117 "src/help.vala"
	bprintf ("%s runs the command %s, which is %s built-in\n" \
"function in `C source code'.\n" \
"\n" \
"%s", _tmp2_, _tmp4_, _tmp0_, _tmp6_, NULL);
#line 633 "help.c"
}

static void
_____lambda94__buffer_writer (gpointer self)
{
#line 113 "src/help.vala"
	____lambda94_ (self);
#line 641 "help.c"
}

static gboolean
__lambda93_ (glong uniarg,
             GeeQueue* args)
{
	Block9Data* _data9_;
	gboolean ok = FALSE;
	gchar* name = NULL;
	gchar* _tmp0_;
	gchar* keystr = NULL;
	gpointer _tmp1_;
	const gchar* _tmp2_;
	gboolean result;
#line 82 "src/help.vala"
	_data9_ = g_slice_new0 (Block9Data);
#line 82 "src/help.vala"
	_data9_->_ref_count_ = 1;
#line 83 "src/help.vala"
	ok = TRUE;
#line 84 "src/help.vala"
	name = NULL;
#line 84 "src/help.vala"
	_tmp0_ = g_strdup ("");
#line 84 "src/help.vala"
	_data9_->binding = _tmp0_;
#line 86 "src/help.vala"
	_tmp1_ = gee_queue_poll (args);
#line 86 "src/help.vala"
	keystr = (gchar*) _tmp1_;
#line 87 "src/help.vala"
	_tmp2_ = keystr;
#line 87 "src/help.vala"
	if (_tmp2_ != NULL) {
#line 676 "help.c"
		GeeList* keys = NULL;
		const gchar* _tmp3_;
		GeeList* _tmp4_;
		GeeList* _tmp5_;
#line 88 "src/help.vala"
		_tmp3_ = keystr;
#line 88 "src/help.vala"
		_tmp4_ = keystrtovec (_tmp3_);
#line 88 "src/help.vala"
		keys = _tmp4_;
#line 89 "src/help.vala"
		_tmp5_ = keys;
#line 89 "src/help.vala"
		if (_tmp5_ != NULL) {
#line 691 "help.c"
			GeeList* _tmp6_;
			LispFunc* _tmp7_;
			LispFunc* _tmp8_;
			const gchar* _tmp9_;
			gchar* _tmp10_;
			GeeList* _tmp11_;
			gchar* _tmp12_;
#line 90 "src/help.vala"
			_tmp6_ = keys;
#line 90 "src/help.vala"
			_tmp7_ = get_function_by_keys (_tmp6_);
#line 90 "src/help.vala"
			_tmp8_ = _tmp7_;
#line 90 "src/help.vala"
			_tmp9_ = _tmp8_->name;
#line 90 "src/help.vala"
			_tmp10_ = g_strdup (_tmp9_);
#line 90 "src/help.vala"
			_g_free0 (name);
#line 90 "src/help.vala"
			name = _tmp10_;
#line 90 "src/help.vala"
			_lisp_func_unref0 (_tmp8_);
#line 91 "src/help.vala"
			_tmp11_ = keys;
#line 91 "src/help.vala"
			_tmp12_ = keyvectodesc (_tmp11_);
#line 91 "src/help.vala"
			_g_free0 (_data9_->binding);
#line 91 "src/help.vala"
			_data9_->binding = _tmp12_;
#line 723 "help.c"
		} else {
#line 93 "src/help.vala"
			ok = FALSE;
#line 727 "help.c"
		}
#line 87 "src/help.vala"
		_g_object_unref0 (keys);
#line 731 "help.c"
	} else {
		GeeList* keys = NULL;
		GeeList* _tmp13_;
		GeeList* _tmp14_;
		LispFunc* _tmp15_;
		LispFunc* _tmp16_;
		const gchar* _tmp17_;
		gchar* _tmp18_;
		GeeList* _tmp19_;
		gchar* _tmp20_;
		const gchar* _tmp21_;
#line 95 "src/help.vala"
		minibuf_write ("Describe key:", NULL);
#line 96 "src/help.vala"
		_tmp13_ = get_key_sequence ();
#line 96 "src/help.vala"
		keys = _tmp13_;
#line 97 "src/help.vala"
		_tmp14_ = keys;
#line 97 "src/help.vala"
		_tmp15_ = get_function_by_keys (_tmp14_);
#line 97 "src/help.vala"
		_tmp16_ = _tmp15_;
#line 97 "src/help.vala"
		_tmp17_ = _tmp16_->name;
#line 97 "src/help.vala"
		_tmp18_ = g_strdup (_tmp17_);
#line 97 "src/help.vala"
		_g_free0 (name);
#line 97 "src/help.vala"
		name = _tmp18_;
#line 97 "src/help.vala"
		_lisp_func_unref0 (_tmp16_);
#line 98 "src/help.vala"
		_tmp19_ = keys;
#line 98 "src/help.vala"
		_tmp20_ = keyvectodesc (_tmp19_);
#line 98 "src/help.vala"
		_g_free0 (_data9_->binding);
#line 98 "src/help.vala"
		_data9_->binding = _tmp20_;
#line 100 "src/help.vala"
		_tmp21_ = name;
#line 100 "src/help.vala"
		if (_tmp21_ == NULL) {
#line 777 "help.c"
			const gchar* _tmp22_;
#line 101 "src/help.vala"
			_tmp22_ = _data9_->binding;
#line 101 "src/help.vala"
			minibuf_error ("%s is undefined", _tmp22_, NULL);
#line 102 "src/help.vala"
			ok = FALSE;
#line 785 "help.c"
		}
#line 87 "src/help.vala"
		_g_object_unref0 (keys);
#line 789 "help.c"
	}
#line 106 "src/help.vala"
	if (ok) {
#line 793 "help.c"
		Block10Data* _data10_;
		const gchar* _tmp23_;
		const gchar* _tmp24_;
		const gchar* _tmp25_;
		LispFunc* _tmp26_;
		LispFunc* _tmp27_;
#line 106 "src/help.vala"
		_data10_ = g_slice_new0 (Block10Data);
#line 106 "src/help.vala"
		_data10_->_ref_count_ = 1;
#line 106 "src/help.vala"
		_data10_->_data9_ = block9_data_ref (_data9_);
#line 107 "src/help.vala"
		_tmp23_ = _data9_->binding;
#line 107 "src/help.vala"
		_tmp24_ = name;
#line 107 "src/help.vala"
		minibuf_write ("%s runs the command `%s'", _tmp23_, _tmp24_, NULL);
#line 109 "src/help.vala"
		_tmp25_ = name;
#line 109 "src/help.vala"
		_tmp26_ = lisp_func_find (_tmp25_);
#line 109 "src/help.vala"
		_data10_->func = _tmp26_;
#line 110 "src/help.vala"
		_tmp27_ = _data10_->func;
#line 110 "src/help.vala"
		if (_tmp27_ == NULL) {
#line 111 "src/help.vala"
			ok = FALSE;
#line 824 "help.c"
		} else {
#line 113 "src/help.vala"
			write_temp_buffer ("*Help*", TRUE, _____lambda94__buffer_writer, _data10_);
#line 828 "help.c"
		}
#line 106 "src/help.vala"
		block10_data_unref (_data10_);
#line 106 "src/help.vala"
		_data10_ = NULL;
#line 834 "help.c"
	}
#line 123 "src/help.vala"
	result = ok;
#line 123 "src/help.vala"
	_g_free0 (keystr);
#line 123 "src/help.vala"
	_g_free0 (name);
#line 123 "src/help.vala"
	block9_data_unref (_data9_);
#line 123 "src/help.vala"
	_data9_ = NULL;
#line 123 "src/help.vala"
	return result;
#line 848 "help.c"
}

static gboolean
___lambda93__function (glong uniarg,
                       GeeQueue* args)
{
	gboolean result;
	result = __lambda93_ (uniarg, args);
#line 80 "src/help.vala"
	return result;
#line 859 "help.c"
}

void
help_init (void)
{
	LispFunc* _tmp0_;
	LispFunc* _tmp1_;
	LispFunc* _tmp2_;
	LispFunc* _tmp3_;
	LispFunc* _tmp4_;
	LispFunc* _tmp5_;
#line 21 "src/help.vala"
	_tmp0_ = lisp_func_new ("describe-function", ___lambda88__function, TRUE, "Display the full documentation of a function.");
#line 21 "src/help.vala"
	_tmp1_ = _tmp0_;
#line 21 "src/help.vala"
	_lisp_func_unref0 (_tmp1_);
#line 51 "src/help.vala"
	_tmp2_ = lisp_func_new ("describe-variable", ___lambda90__function, TRUE, "Display the full documentation of a variable.");
#line 51 "src/help.vala"
	_tmp3_ = _tmp2_;
#line 51 "src/help.vala"
	_lisp_func_unref0 (_tmp3_);
#line 80 "src/help.vala"
	_tmp4_ = lisp_func_new ("describe-key", ___lambda93__function, TRUE, "Display documentation of the command invoked by a key sequence.");
#line 80 "src/help.vala"
	_tmp5_ = _tmp4_;
#line 80 "src/help.vala"
	_lisp_func_unref0 (_tmp5_);
#line 889 "help.c"
}

